<?PHP
$starttime = microtime(true);
set_time_limit(20);
?>
<!doctype html>
<html>
<head>
	<title>TS-N.NET ClientCleaner</title>
	<meta http-equiv="content-type" content="text/html; charset=utf-8" />
	<style type="text/css">
	body{font-family:Century Gothic,sans-serif;font-size:15px;color:#707070;}
	.ifcolor{color:#3366CC;}
	.wncolor{color:#CC0000;}
	.sccolor{color:#008000;}
	.size2{font-size:16px;font-weight:bold;}
	</style>
</head><body>
<table>
<?PHP
require_once('config.php');
require_once('ts3_lib/TeamSpeak3.php');

$deletetime = time() - $deletiontime;

try {
    $ts3_VirtualServer = TeamSpeak3::factory("serverquery://" . $ts['user'] . ":" . $ts['pass'] . "@" . $ts['host'] . ":" . $ts['query'] . "/?server_port=" . $ts['voice']);
    $nowtime           = time();
    if ($slowmode == 1)
        sleep(1);
    try {
        $ts3_VirtualServer->selfUpdate(array(
            'client_nickname' => $queryname
        ));
    }
    catch (Exception $e) {
        if ($slowmode == 1)
            sleep(1);
        try {
            $ts3_VirtualServer->selfUpdate(array(
                'client_nickname' => $queryname2
            ));
            echo 'First Queryname already in use. Try with second Queryname...<br><br>';
        }
        catch (Exception $e) {
            echo 'Error ', $e->getCode(), ': ', $e->getMessage();
        }
    }
		
	$clientdblist=array();
	while($getclientdblist=$ts3_VirtualServer->clientListDb($start, $break)) {
		if(count($getclientdblist)<$break) {
			break;
		}
		$clientdblist=array_merge($clientdblist, $getclientdblist);
		$start=$start+$break;
		if ($start == $limit) {
			break;
		}
		if ($slowmode == 1)
            sleep(1);
	}
	
	if ($update == 1) {
		set_error_handler(function() { });
		$newversion = file_get_contents('http://ts-n.net/clientcleaner/version');
		restore_error_handler();
		if (substr($newversion, 0, 4) != substr($currvers, 0, 4) && $newversion != '') {
			echo '<span class="size2">A new Version of the ClientCleaner is available; Inform Clients on Server...</span><br>';
			foreach ($uniqueid as $clientid) {
				if ($slowmode == 1)
					sleep(1);
				try {
					if ($slowmode == 1)
						sleep(1);
					$ts3_VirtualServer->clientGetByUid($clientid)->message(sprintf('
Hey, a new version of the [B]ClientCleaner[/B] is available!

current version: %s
[B]new version: %s[/B]

Please check out our site for more informations [URL]http://ts-n.net/clientcleaner.php[/URL].', $currvers, $newversion));
					echo '<span class="sccolor">', sprintf('User %s was successfully informed.', $clientid), '</span><br>';
				}
				catch (Exception $e) {
					echo '<span class="wncolor">', sprintf('The unique Client-ID %s couldn\'t reached on the TeamSpeak!', $clientid), '</span><br>';
				}
			}
			echo '<br><br>';
		}
    }
	
	$delcount = 0;
	$errcount = 0;
	
	echo '<span class="size2">Search for old Clients...</span><br>';
	foreach ($clientdblist as $client) {
		if ($client['client_lastconnected'] < $deletetime) {
			if ($simulate_mode == 1) {
				echo '<tr><td>Client</td><td><b>' , $client['client_nickname'] , '</b></td><td>(cldbid: ' , $client['cldbid'] , ' </td><td>uuid: ' , $client['client_unique_identifier'] , ')</td><td> was last seen on <b>' , date('Y-m-d H:i:s',$client['client_lastconnected']) , '</b></td><td> and would be deleted without <b>simulation</b>.</td></tr>';
			} else {
				try {
					if ($slowmode == 1)
						sleep(1);
					$ts3_VirtualServer->clientDeleteDb($client['cldbid']);
					echo '<tr><td>Client</td><td><b>' , $client['client_nickname'] , '</b></td><td>(cldbid: ' , $client['cldbid'] , ' </td><td>uuid: ' , $client['client_unique_identifier'] , ')</td><td> was last seen on <b>' , date('Y-m-d H:i:s',$client['client_lastconnected']) , '</b></td><td> and was deleted now.</td></tr>';
					$delcount++;
				}
				catch (Exception $e) {
				echo '<tr><td><span class="wncolor">Client</span></td><td><span class="wncolor"><b>' , $client['client_nickname'] , '</b></span></td><td><span class="wncolor">(cldbid: ' , $client['cldbid'] , ' </span></td><td><span class="wncolor">uuid: ' , $client['client_unique_identifier'] , ')</span></td><td><span class="wncolor"> was last seen on <b>' , date('Y-m-d H:i:s',$client['client_lastconnected']) , '</b></span></td><td><span class="wncolor"> and could not been deleted cause an error occurred.</span></td></tr>';
				$errcount++;
				}
			}
		}
	}
}
catch (Exception $e) {
    echo $e->getCode() . ': ' . $e->getMessage();
}
$buildtime = microtime(true) - $starttime;
echo '</table><br>',$delcount,' clients deleted; ',$errcount,' error by deletion<br><br>';
echo sprintf("Site generated in %s seconds with %s clients out of the TeamSpeak database.", $buildtime, $clientdblist[0]['count']), '<br>';
?>
</body>
</html>